/**********************************************************************************
** Split Studio v1.1 (22.6.2000)
** (c) by Gian Davide Alfano
** This program is FREEWARE
** For any question, suggestion, donation(?) write to:
** alfagiandy@libero.it
** http://digilander.iol.it
**
** Portions of code generated by BeBuilder Release V0.5.2                
** Written by Jerome Fillon (Softimedia Inc.)
**
** This program is free software; you can redistribute it and/or 
** modify it under the terms of the GNU General Public License 
** as published by the Free Software Foundation; either version 2 
** of the License, or (at your option) any later version. 
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of 
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
** GNU General Public License for more details. 
**
** You should have received a copy of the GNU General Public License 
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** HISTORY
** 1.0 (17.6.00) : first release
** 1.1 (22.6.00) : Now SplitStudio is a complete and standalone program
**				   It is a complete shell command with a nice GUI (see docs
**				   	about the arguments)
**				   Removed the Prefix TextControl (SplitStudio creates more 
**				   	significant file names :-))
**				   Added a Parts item to the Unit menu as starting with 1.1
**					you can specify the parts the source file will be splitted in
**
**********************************************************************************/

#include "PostDispatchInvoker.h"
#include "ABoxSplit.h"
#include "dosplit.h"

#include <MenuItem.h>
#include <Alert.h>
#include <FilePanel.h>
#include <StorageKit.h>
#include <Entry.h>
#include <Roster.h>
#include <Path.h>
#include <Directory.h>
#include <String.h>
#include <ScrollView.h>
#include <ListView.h>
#include <Window.h>
#include <NetPositive.h>
#include <File.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define ABOUT_TEXT "Split Studio v1.1 (22.6.00)\n(c) 2000 by Gian Davide Alfano\n\nhttp://digilander.iol.it/gdalfano/\nalfagiandy@libero.it"
#define REBUILD_ALERT "This function is not implemented yet.\nPlease, use the Rebuild Add-on to rebuild split files."

extern BWindow *MyWin;

// This class represents the three popup menus (mode, size and unit)
fMenuItem::fMenuItem(const char *name, BMessage *message,
	uint32 size=0, int mode=SPLIT, char unit='b') : BMenuItem(name, message) {

	this->size = size;
	this->mode = mode;
	this->unit = unit;
}

// Init the GUI
TBoxSplit::TBoxSplit(BRect AFrame): BBox(AFrame,"ABoxSplit",B_FOLLOW_ALL_SIDES,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE)
{	
	BRect ARectATextControlPath(8.000000,23.000000,290.000000,53.000000);
	FATextControlPath=new BTextControl(ARectATextControlPath,"ATextControlPath","File:","",new BMessage(SN_PATH),B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FATextControlPath->SetDivider(30);
	
	BRect ARectATextControlDir(8.000000,81.000000,290.000000,105.000000);
	FATextControlDir=new BTextControl(ARectATextControlDir,"ATextControlDir","Destination:","",new BMessage(SN_DIR),B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FATextControlDir->SetDivider(60);	
	
	BRect ARectATextControlSize(108,51,290.000000,80);
	FATextControlSize=new BTextControl(ARectATextControlSize,"ATextControlSize","","",new BMessage(SN_SIZE),B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FATextControlSize->SetDivider(0);
	FATextControlSize->SetAlignment(B_ALIGN_LEFT,B_ALIGN_RIGHT);	
	
//	BRect ARectATextControlPrefix(8.000000,111.000000,200.000000,141.000000);
//	FATextControlPrefix=new BTextControl(ARectATextControlPrefix,"ATextControlPrefix","Prefix:","",new BMessage(SN_PREFIX),B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
//	FATextControlPrefix->SetDivider(35);	
	
	BRect ARectAButtonSelect(296.000000,19.000000,368.000000,45.000000);
	FAButtonSelect=new BButton(ARectAButtonSelect,"AButtonSelect","Select...",new BMessage(SN_SELECT),B_FOLLOW_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FAButtonSelect->MakeDefault(FALSE);	
	
	BRect ARectAButtonDir(296.000000,78.000000,368.000000,97.000000);
	FAButtonDir=new BButton(ARectAButtonDir,"AButtonDir","Select...",new BMessage(SN_DIR_SEL),B_FOLLOW_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FAButtonDir->MakeDefault(FALSE);
	
	BRect ARectAButtonGo(290.000000,109.000000,368.000000,135.000000);
	FAButtonGo=new BButton(ARectAButtonGo,"AButtonGo","Go!",new BMessage(SN_GO),B_FOLLOW_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FAButtonGo->MakeDefault(FALSE);
	FAButtonGo->SetEnabled(false);
	
	BRect ARectAButtonAbout(207.000000,109.000000,285.000000,135.000000);
	FAButtonAbout=new BButton(ARectAButtonAbout,"AButtonAbout","About...",new BMessage(SN_ABOUT),B_FOLLOW_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	FAButtonAbout->MakeDefault(FALSE);

//  The ListView will be implemented in the next release
//	BRect ARectAListView(8.000000,85.000000,350.000000,290.000000);
//	FAListView=new BListView(ARectAListView,"AListViewComponent3",B_SINGLE_SELECTION_LIST,B_FOLLOW_LEFT | B_FOLLOW_TOP,B_NAVIGABLE | B_FRAME_EVENTS | B_WILL_DRAW);
//	FAScrollView = new BScrollView("scroll_AListView",FAListView,B_FOLLOW_ALL_SIDES ,B_NAVIGABLE | B_FRAME_EVENTS | B_WILL_DRAW,true,true);
//	AddChild(FAScrollView);
	
	strcpy(current_prefix,"x");
	strcpy(destdir,"");
}

TBoxSplit::~TBoxSplit(void)
{
	delete fOpenPanel;
	delete fDirPanel;
	delete fSavePanel;
}

void TBoxSplit::MessageReceived(BMessage *message)
{	
	entry_ref ref, dir, shref;
	const char *name = NULL;
	BPath fpath, filepath;
	BDirectory ddir;
	char s[B_FILE_NAME_LENGTH], strerr[B_FILE_NAME_LENGTH];
	static char destname[B_FILE_NAME_LENGTH];
	int err;
	
	switch(message->what)
	{
		case SN_SIZE_144:
		case SN_SIZE_720:
		case SN_SIZE_CUSTOM:	
			DoSizeMenu();
	 		break;
	 	
	 	case SN_REBUILD:
			//MsgBox(REBUILD_ALERT, "Ok", B_STOP_ALERT);
			//fMode->ItemAt(SPLIT)->SetMarked(true);
			//break;
		
		case SN_SPLIT:
			DoModeMenu();
	 		break;
	 	
	 	case SN_BYTES:
		case SN_KILOS:
		case SN_MEGS:
		case SN_PARTS:	
			DoUnitMenu();
	 		break;
		
		case SN_SIZE :
			current_size = atol(FATextControlSize->Text());
			break;
			
		case SN_PREFIX :
			strcpy(current_prefix,FATextControlPrefix->Text());
			break;
		
		case SN_PATH :
			// if Path TextControl is NULL we disable the Go button
			strcpy(sourcefile,FATextControlPath->Text());
			if (strncmp(sourcefile,"",strlen(sourcefile)))
				FAButtonGo->SetEnabled(true);
			else
				FAButtonGo->SetEnabled(false);
			break;
		
		case SN_DIR :
			strcpy(destdir,FATextControlDir->Text());
			break;
		
		case SN_ABOUT :
			MsgBox(ABOUT_TEXT, "Cool!", B_IDEA_ALERT);
			break;
			
		case SN_GO :
			// Here we go!			
			if (current_size==0) {
				MsgBox("Size can't be zero! Change the value please","Ok",B_WARNING_ALERT);
				break;
			}
			if (strcmp(destdir,"")!=0)
			{
				ddir.SetTo(destdir);
				if (ddir.InitCheck()==B_ENTRY_NOT_FOUND)
				{
					sprintf(strerr,"%s non è un percorso valido. Scrivo in /boot/home.",destdir);
					MsgBox(strerr,"ok",B_WARNING_ALERT);
					sprintf(destdir,"/boot/home");
				}
			}
			
			if (!strncmp(destdir,"",strlen(destdir))) sprintf(destdir,".");
			filepath.SetTo(sourcefile);
			
			if (current_mode==REBUILD)
			{
				BFile sorg(filepath.Path(),B_READ_ONLY);
				if (sorg.InitCheck()!=B_OK)
				{
					MsgBox("File doesn't exist","Ok",B_WARNING_ALERT);
					break;
				}
				if (sorg.ReadAttr("SPLITSTUDIO",0,0,destname,B_FILE_NAME_LENGTH)==B_ENTRY_NOT_FOUND)
				{
					MsgBox("This file has not been created by SplitStudio\n","Ok",B_WARNING_ALERT);
					break;
				}
				sorg.ReadAttr("FILENAME",0,0,destname,B_FILE_NAME_LENGTH);
				sorg.ReadAttr("PARTS",0,0,&current_size,sizeof(current_size));
				sorg.Unset();
				
				sprintf(strerr,"SplitStudio will attempt to rebuild %s/%s from %d files\n",destdir,destname,(int)current_size);
				
				err = dorebuild((char *)filepath.Path(),destdir,destname,(int)current_size);
			} else err = dosplit(filepath,destdir,current_size,current_unit);
			
			switch (err)
			{
				case ERR_OPEN_DEST_FILE:
					sprintf(strerr,"Could not open %s/%s\n",destdir,destname);
					break;
				case ERR_OPEN_REBUILD_FILE:
					sprintf(strerr,"One of the file parts is missing or cannot be opened\n");
					break;
				case ERR_OPEN_FILE:
					sprintf(strerr,"Could not open %s",filepath.Path());
					break;
				case ERR_FILE_TOO_SMALL:
					sprintf(strerr,"File too small to be splitted!");
					break;
				case ERR_WRITING:
					sprintf(strerr,"Error reading %s",filepath.Path());
					break;
				case ERR_READING:
					sprintf(strerr,"Error splitting file");
					break;
				case DONE_SPLIT:
				case DONE_REBUILD:
					sprintf(strerr,"Work done.");
					break;
				case ERR_SPLIT_FILE:
					sprintf(strerr,"%s is not a SplitStudio generated file.\n",filepath.Path());
					break;
			}
			MsgBox(strerr,"OK",B_WARNING_ALERT);
			break;
	 	
	 	case SN_SELECT :
	 		DoFilePanel();
			break;
		
		case SN_DIR_SEL :
	 		fDirPanel->Show();
			break;
		
		case B_REFS_RECEIVED :
			// We are receiveing notification if the user has selected a file from
			// the file panel and has dropped a file in the view.
			// We are also notificated if the addon interface sends us a ref to a file
			
			if (message->FindRef("refs", &ref) == B_NO_ERROR) {
				
				BEntry entry(&ref,true);
				entry.GetPath(&fpath);
				
				BFile sorg(fpath.Path(),B_READ_ONLY);
				if (sorg.InitCheck()!=B_OK)
				{
					MsgBox("File doesn't exist","Ok",B_WARNING_ALERT);
					break;
				}
				
				if (sorg.ReadAttr("SPLITSTUDIO",0,0,destname,B_FILE_NAME_LENGTH)==B_ENTRY_NOT_FOUND)
				{
					if (current_mode==REBUILD)
					{
						MsgBox("This file has not been created by SplitStudio\n","Ok",B_WARNING_ALERT);
						break;
					}
				} else {
					sorg.ReadAttr("FILENAME",0,0,destname,B_FILE_NAME_LENGTH);
					sorg.ReadAttr("PARTS",0,0,&current_size,sizeof(current_size));
					sorg.Unset();
					
					fMode->ItemAt(REBUILD)->SetMarked(true);
					DoModeMenu();	
				}				
				
				// Here we get the size in bytes of the file and display it in the Size TextControl...
				BFile file(&entry,B_READ_ONLY);
				off_t size;
				file.GetSize(&size);
				sprintf(s,"%d",(int)size);
				current_size = size;
				FATextControlSize->SetText(s);
				fUnit->ItemAt(0)->SetMarked(true);
				DoUnitMenu();
				
				// ... and display the filename
				sprintf(sourcefile, "%s",fpath.Path());
				FATextControlPath->SetText(sourcefile);
				MyWin->PostMessage(new BMessage(SN_PATH),(BHandler *)this);
			
			}
			break;
		
		case DESTDIR :
			// The user has selected a destination directory
			if (message->FindRef("refs", &ref) == B_NO_ERROR) {
				
				BEntry entry(&ref,true);
				BPath fpath;
				entry.GetPath(&fpath);

				sprintf(destdir, "%s",fpath.Path());
				FATextControlDir->SetText(destdir);
				MyWin->PostMessage(new BMessage(SN_DIR),(BHandler *)this);
			
			}
			break;
			
		case B_SAVE_REQUESTED :
			// We are requested to select the file to rebuild		
			if (message->FindRef("refs", &dir) == B_NO_ERROR) {
				BEntry filetorebuild(&dir,true);
				message->FindString("name", &name);
				BPath fpath;
				filetorebuild.GetPath(&fpath);
				fpath.Append(name,true);
				sprintf(sourcefile, "%s",fpath.Path());
				FATextControlPath->SetText(sourcefile);
				MyWin->PostMessage(new BMessage(SN_PATH),(BHandler *)this);
			}
			break;
					
		default :
			BBox::MessageReceived(message);
			break;
	}
}
void TBoxSplit::AttachedToWindow(void)
{
	// We attach the BControl to this view
	AddChild(FATextControlPath);
	AddChild(FAButtonSelect);
	SetSizeMenu();
	AddChild(FATextControlSize);
	SetUnitMenu();
	AddChild(FATextControlDir);
	AddChild(FAButtonDir);
	//AddChild(FATextControlPrefix);
	AddChild(FAButtonAbout);
	AddChild(FAButtonGo);

	// Make this view the standard handler for the various controls
	FAButtonSelect->SetTarget(this);
	FATextControlPath->SetTarget(this);
	FATextControlPath->TextView()->AddFilter(new PostDispatchInvoker(B_KEY_DOWN, new BMessage(SN_PATH), this));
	// We add a filter so we get a MOUSEDOWN message for sudden notification
	FATextControlSize->SetTarget(this);
	FATextControlSize->TextView()->AddFilter(new PostDispatchInvoker(B_KEY_DOWN, new BMessage(SN_SIZE), this));
//	FATextControlPrefix->SetTarget(this);
//	FATextControlPrefix->TextView()->AddFilter(new PostDispatchInvoker(B_KEY_DOWN, new BMessage(SN_PREFIX), this));
	FATextControlDir->SetTarget(this);
	FATextControlDir->TextView()->AddFilter(new PostDispatchInvoker(B_KEY_DOWN, new BMessage(SN_DIR), this));
	FAButtonGo->SetTarget(this);
	FAButtonDir->SetTarget(this);
	FAButtonAbout->SetTarget(this);
//	FAListView->SetTarget(this);
	
	SetLabel(SetModeMenu()); // Attach a Popup menu to the Box label
	DoSizeMenu();
	DoUnitMenu();
	DoModeMenu();
	
	// Instantiate three different FilePanels
	fOpenPanel = new BFilePanel(B_OPEN_PANEL, new BMessenger(this), NULL, B_FILE_NODE, false);
	fDirPanel = new BFilePanel(B_OPEN_PANEL, new BMessenger(this), NULL, B_DIRECTORY_NODE, false, new BMessage(DESTDIR));
	fSavePanel = new BFilePanel(B_SAVE_PANEL, new BMessenger(this), NULL, B_FILE_NODE, false);
	
	BBox::AttachedToWindow();
}

// Do the right thing according to the selected item
void TBoxSplit::DoSizeMenu(void)
{
	fMenuItem *item = (fMenuItem *)fSize->FindMarked();
	int index = fSize->IndexOf(item);
	
	if (index==2) { //Custom
		FATextControlSize->SetEnabled(true);
		fUnit->SetEnabled(true);
		current_size = 0;
		DoUnitMenu();
	} else { // Gets the standard sizes from the selected item
		current_size = item->size;
		current_unit = ' ';
		FATextControlSize->SetEnabled(false);
		fUnit->SetEnabled(false);
	}
}

void TBoxSplit::DoModeMenu(void)
{
	fMenuItem *item = (fMenuItem *)fMode->FindMarked();
//  Not implemented yet

	int index = fMode->IndexOf(item);

	if (index==REBUILD) {
		current_mode = item->mode; 
		FATextControlSize->SetEnabled(false);
		fSize->SetEnabled(false);
		fUnit->SetEnabled(false);
		//FAListView->SetEnabled(false);
	} else {
		current_mode=item->mode;
		FATextControlSize->SetEnabled(true);
		fSize->SetEnabled(true);
		fUnit->SetEnabled(true);
//		FAListView->SetEnabled(true);
	}
}

void TBoxSplit::DoUnitMenu(void)
{
	fMenuItem *item = (fMenuItem *)fUnit->FindMarked();
	
	//char old_unit = current_unit;
	current_unit = item->unit;	
	
	// Convert the current_size (and display it) according to the current unit	
	//switch (old_unit)
//	{
//		case 'b' :
//			if (current_unit=='k') current_size = current_size/K;
//			else if (current_unit=='m') current_size = current_size/(K*K);
//			break;
//			
//		case 'k' :
//			if (current_unit==' ') current_size = current_size*K;
//			else if (current_unit=='m') current_size = current_size/K;
//			break;
//		
//		case 'm' :
//			if (current_unit==' ') current_size = current_size*K*K;
//			else if (current_unit=='k') current_size = current_size*K;
//			break;
//	}
	
//	BString a = "";
//	a << current_size;
//	FATextControlSize->SetText(a.String());	
}

void TBoxSplit::DoFilePanel(void)
{
	if (current_mode==SPLIT)
		fOpenPanel->Show();
	else
		fSavePanel->Show();
}

// The following build the popup radio menus
void TBoxSplit::SetSizeMenu(void)
{
	fMenuItem *item;
	
	fSize = new BPopUpMenu("Size",true);
	
	item = new fMenuItem("720kb", new BMessage(SN_SIZE_720), SIZE_720*K);
	item->SetTarget(this);	
	fSize->AddItem(item , 0);
	item = new fMenuItem("1.44Mb", new BMessage(SN_SIZE_144), SIZE_144*K*10);
	item->SetTarget(this);	
	fSize->AddItem(item , 1);
	item = new fMenuItem("Custom...", new BMessage('CUST'), 0);
	item->SetTarget(this);
	item->SetMarked(true);
	fSize->AddItem(item , 2);
		
	BRect rect(8,50,103,200);
	field = new BMenuField(rect, "SizeMenu", "Size:", fSize);
	field->SetDivider(30);
	field->SetEnabled(TRUE);
	AddChild(field);
}

BView *TBoxSplit::SetModeMenu(void)
{
	fMenuItem *item;
	
	fMode = new BPopUpMenu("Mode",true);
	
	item = new fMenuItem("Split", new BMessage(SN_SPLIT),0,SPLIT);
	item->SetTarget(this);	
	item->SetMarked(true);
	fMode->AddItem(item , SPLIT);		
	item = new fMenuItem("Rebuild", new BMessage(SN_REBUILD),0,REBUILD);
	item->SetTarget(this);	
	fMode->AddItem(item , REBUILD);	


		
	BRect rect(5,5,100,200);
	field = new BMenuField(rect, "ModeMenu", "", fMode);
	field->SetDivider(0);
	field->SetEnabled(TRUE);
	return field;
}

void TBoxSplit::SetUnitMenu(void)
{
	fMenuItem *item;
	
	fUnit = new BPopUpMenu("Unit",true);
		
	item = new fMenuItem("bytes", new BMessage(SN_BYTES));
	item->SetTarget(this);
	item->SetMarked(true);	
	fUnit->AddItem(item , 0);	
	item = new fMenuItem("Kbytes", new BMessage(SN_KILOS),0,0,'k');
	item->SetTarget(this);	
	fUnit->AddItem(item , 1);
	item = new fMenuItem("Megs", new BMessage(SN_MEGS),0,0,'m');
	item->SetTarget(this);	
	fUnit->AddItem(item , 2);
	item = new fMenuItem("Parts", new BMessage(SN_PARTS),0,0,'p');
	item->SetTarget(this);	
	fUnit->AddItem(item , 3);
		
	BRect rect(305,50,400,200);
	field = new BMenuField(rect, "UnitMenu", "", fUnit,B_FOLLOW_RIGHT | B_FOLLOW_TOP,B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	field->SetDivider(0);
	field->SetEnabled(TRUE);
	AddChild(field);
}

// Bring a BAlert...
void TBoxSplit::MsgBox(char *str, char *button, alert_type type = B_IDEA_ALERT)
{
	if (0==(new BAlert("SplitStudio", str, "Help", button, NULL, B_WIDTH_AS_USUAL, type))->Go())
	{
		
		app_info info; 
   	 	BPath path; 
    
    	be_app->GetAppInfo(&info); 
    	BEntry entry(&info.ref); 
    	entry.GetPath(&path); 
    	path.GetParent(&path);
		path.Append("SplitStudio.html");
		char s[B_FILE_NAME_LENGTH];
		sprintf(s,"file://%s",path.Path());
		BMessage *msg = new BMessage(B_NETPOSITIVE_OPEN_URL);
		msg->AddString("be:url",s);
		if(B_LAUNCH_FAILED==be_roster->Launch(B_NETPOSITIVE_APP_SIGNATURE,msg))
		{
			(new BAlert("Help", "Can't load NetPositive", "OK",NULL,NULL,B_WIDTH_AS_USUAL,B_WARNING_ALERT))->Go();
		}
	}
}
